using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IBranchRepository
    {
        Task<BaseResult> Add(BranchElastic Branch);
        Task<BaseResult> AddManyAsync(IEnumerable<BranchElastic> Branchs);
        Task<SmartTableResult<BranchElastic>> Search(BoolQueryDescriptor<BranchElastic> query);

    }
    public class BranchRepository : IBranchRepository
    {
        private readonly ElasticIndex<BranchElastic> _dbContext;

        public BranchRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<BranchElastic>(settings.Value.ClusterUrl, "inventorybranch");
        }


        public async Task<SmartTableResult<BranchElastic>> Search(BoolQueryDescriptor<BranchElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(BranchElastic Branch)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Branch);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<BranchElastic> Branchs)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Branchs);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

    }
}
